"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  Checkbox: () => Checkbox,
  useCheckbox: () => useCheckbox
});
module.exports = __toCommonJS(src_exports);

// src/parts/Control.tsx
var import_react5 = require("react");
var import_dive = require("@react-dive-ui/dive");
var import_merge_props = require("@react-dive-ui/merge-props");
var import_compose_event_handlers = require("@react-dive-ui/compose-event-handlers");

// src/checkbox-provider/CheckboxProvider.tsx
var import_react3 = require("react");

// src/useCheckbox.ts
var import_react = require("react");
var import_react2 = require("@xstate/react");
var import_checkbox_machine = require("@react-dive-ui/checkbox-machine");
function useCheckbox(options = {}) {
  var _a;
  const internalId = (0, import_react.useId)();
  const [state, send] = (0, import_react2.useActor)(
    import_checkbox_machine.machine.provide({
      actions: {
        onChange: ({ context: context2 }) => {
          var _a2;
          (_a2 = options.onChange) == null ? void 0 : _a2.call(options, context2.checkedState);
        }
      }
    }),
    {
      input: {
        id: (_a = options.id) != null ? _a : internalId,
        checkedState: options.checkedState,
        disabled: options.disabled,
        form: options.form,
        value: options.value
      }
    }
  );
  console.log("----------");
  console.log(state.context);
  const check = (0, import_react.useCallback)(() => {
    send({ type: "CHECK" });
  }, [send]);
  const setChecked = (0, import_react.useCallback)(
    (checked) => {
      send({ type: "SET.CHECKED", checked });
    },
    [send]
  );
  const setIndeterminate = (0, import_react.useCallback)(() => {
    send({ type: "SET.INDETERMINATE" });
  }, [send]);
  const setDisabled = (0, import_react.useCallback)(
    (disabled) => {
      send({ type: "SET.DISABLED", disabled });
    },
    [send]
  );
  const { value, context } = state;
  return {
    state: __spreadValues({
      status: value
    }, context),
    apis: { check, setChecked, setIndeterminate, setDisabled },
    props: (0, import_checkbox_machine.connect)(state, send)
  };
}

// src/checkbox-provider/CheckboxProvider.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var CheckboxContext = (0, import_react3.createContext)(void 0);
var CheckboxProvider = (_a) => {
  var _b = _a, {
    children
  } = _b, options = __objRest(_b, [
    "children"
  ]);
  const checkbox = useCheckbox(options);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(CheckboxContext.Provider, { value: checkbox, children });
};

// src/checkbox-provider/useCheckboxContext.ts
var import_react4 = require("react");
function useCheckboxContext() {
  const context = (0, import_react4.useContext)(CheckboxContext);
  if (!context)
    throw new Error("CheckboxProvider\uB97C \uCC3E\uC9C0 \uBABB\uD588\uC2B5\uB2C8\uB2E4");
  return context;
}

// src/parts/Control.tsx
var import_jsx_runtime2 = require("react/jsx-runtime");
var Control = (0, import_react5.forwardRef)(
  (props, ref) => {
    const context = useCheckboxContext();
    const { controlProps } = context.props;
    const mergedProps = (0, import_merge_props.mergeProps)(controlProps, props);
    return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
      import_dive.dive.button,
      __spreadProps(__spreadValues({}, mergedProps), {
        onClick: (0, import_compose_event_handlers.composeEventHandlers)(props.onClick, controlProps.onClick),
        ref
      })
    );
  }
);
Control.displayName = "Checkbox.Control";

// src/parts/Label.tsx
var import_react6 = require("react");
var import_dive2 = require("@react-dive-ui/dive");
var import_merge_props2 = require("@react-dive-ui/merge-props");
var import_compose_event_handlers2 = require("@react-dive-ui/compose-event-handlers");
var import_jsx_runtime3 = require("react/jsx-runtime");
var Label = (0, import_react6.forwardRef)((props, ref) => {
  const context = useCheckboxContext();
  const { labelProps } = context.props;
  const mergedProps = (0, import_merge_props2.mergeProps)(labelProps, props);
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
    import_dive2.dive.label,
    __spreadProps(__spreadValues({}, mergedProps), {
      onClick: (0, import_compose_event_handlers2.composeEventHandlers)(props.onClick, labelProps.onClick),
      ref
    })
  );
});
Label.displayName = "Checkbox.Label";

// src/parts/HiddenInput.tsx
var import_react7 = require("react");
var import_dive3 = require("@react-dive-ui/dive");
var import_merge_props3 = require("@react-dive-ui/merge-props");
var import_compose_event_handlers3 = require("@react-dive-ui/compose-event-handlers");
var import_jsx_runtime4 = require("react/jsx-runtime");
var HiddenInput = (0, import_react7.forwardRef)(
  (props, ref) => {
    const context = useCheckboxContext();
    const { hiddenInputProps } = context.props;
    const mergedProps = (0, import_merge_props3.mergeProps)(hiddenInputProps, props);
    return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
      import_dive3.dive.input,
      __spreadProps(__spreadValues({}, mergedProps), {
        onChange: (0, import_compose_event_handlers3.composeEventHandlers)(
          props.onChange,
          hiddenInputProps.onChange
        ),
        ref
      })
    );
  }
);
HiddenInput.displayName = "Checkbox.HiddenInput";

// src/Checkbox.tsx
var Checkbox = Object.assign(
  {},
  { Provider: CheckboxProvider, Control, Label, HiddenInput }
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Checkbox,
  useCheckbox
});
