var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};

// src/parts/Control.tsx
import { forwardRef } from "react";
import { dive } from "@react-dive-ui/dive";
import { mergeProps } from "@react-dive-ui/merge-props";
import { composeEventHandlers } from "@react-dive-ui/compose-event-handlers";

// src/checkbox-provider/CheckboxProvider.tsx
import { createContext } from "react";

// src/useCheckbox.ts
import { useCallback, useId } from "react";
import { useActor } from "@xstate/react";
import {
  machine,
  connect
} from "@react-dive-ui/checkbox-machine";
function useCheckbox(options = {}) {
  var _a;
  const internalId = useId();
  const [state, send] = useActor(
    machine.provide({
      actions: {
        onChange: ({ context: context2 }) => {
          var _a2;
          (_a2 = options.onChange) == null ? void 0 : _a2.call(options, context2.checkedState);
        }
      }
    }),
    {
      input: {
        id: (_a = options.id) != null ? _a : internalId,
        checkedState: options.checkedState,
        disabled: options.disabled,
        form: options.form,
        value: options.value
      }
    }
  );
  console.log("----------");
  console.log(state.context);
  const check = useCallback(() => {
    send({ type: "CHECK" });
  }, [send]);
  const setChecked = useCallback(
    (checked) => {
      send({ type: "SET.CHECKED", checked });
    },
    [send]
  );
  const setIndeterminate = useCallback(() => {
    send({ type: "SET.INDETERMINATE" });
  }, [send]);
  const setDisabled = useCallback(
    (disabled) => {
      send({ type: "SET.DISABLED", disabled });
    },
    [send]
  );
  const { value, context } = state;
  return {
    state: __spreadValues({
      status: value
    }, context),
    apis: { check, setChecked, setIndeterminate, setDisabled },
    props: connect(state, send)
  };
}

// src/checkbox-provider/CheckboxProvider.tsx
import { jsx } from "react/jsx-runtime";
var CheckboxContext = createContext(void 0);
var CheckboxProvider = (_a) => {
  var _b = _a, {
    children
  } = _b, options = __objRest(_b, [
    "children"
  ]);
  const checkbox = useCheckbox(options);
  return /* @__PURE__ */ jsx(CheckboxContext.Provider, { value: checkbox, children });
};

// src/checkbox-provider/useCheckboxContext.ts
import { useContext } from "react";
function useCheckboxContext() {
  const context = useContext(CheckboxContext);
  if (!context)
    throw new Error("CheckboxProvider\uB97C \uCC3E\uC9C0 \uBABB\uD588\uC2B5\uB2C8\uB2E4");
  return context;
}

// src/parts/Control.tsx
import { jsx as jsx2 } from "react/jsx-runtime";
var Control = forwardRef(
  (props, ref) => {
    const context = useCheckboxContext();
    const { controlProps } = context.props;
    const mergedProps = mergeProps(controlProps, props);
    return /* @__PURE__ */ jsx2(
      dive.button,
      __spreadProps(__spreadValues({}, mergedProps), {
        onClick: composeEventHandlers(props.onClick, controlProps.onClick),
        ref
      })
    );
  }
);
Control.displayName = "Checkbox.Control";

// src/parts/Label.tsx
import { forwardRef as forwardRef2 } from "react";
import { dive as dive2 } from "@react-dive-ui/dive";
import { mergeProps as mergeProps2 } from "@react-dive-ui/merge-props";
import { composeEventHandlers as composeEventHandlers2 } from "@react-dive-ui/compose-event-handlers";
import { jsx as jsx3 } from "react/jsx-runtime";
var Label = forwardRef2((props, ref) => {
  const context = useCheckboxContext();
  const { labelProps } = context.props;
  const mergedProps = mergeProps2(labelProps, props);
  return /* @__PURE__ */ jsx3(
    dive2.label,
    __spreadProps(__spreadValues({}, mergedProps), {
      onClick: composeEventHandlers2(props.onClick, labelProps.onClick),
      ref
    })
  );
});
Label.displayName = "Checkbox.Label";

// src/parts/HiddenInput.tsx
import { forwardRef as forwardRef3 } from "react";
import { dive as dive3 } from "@react-dive-ui/dive";
import { mergeProps as mergeProps3 } from "@react-dive-ui/merge-props";
import { composeEventHandlers as composeEventHandlers3 } from "@react-dive-ui/compose-event-handlers";
import { jsx as jsx4 } from "react/jsx-runtime";
var HiddenInput = forwardRef3(
  (props, ref) => {
    const context = useCheckboxContext();
    const { hiddenInputProps } = context.props;
    const mergedProps = mergeProps3(hiddenInputProps, props);
    return /* @__PURE__ */ jsx4(
      dive3.input,
      __spreadProps(__spreadValues({}, mergedProps), {
        onChange: composeEventHandlers3(
          props.onChange,
          hiddenInputProps.onChange
        ),
        ref
      })
    );
  }
);
HiddenInput.displayName = "Checkbox.HiddenInput";

// src/Checkbox.tsx
var Checkbox = Object.assign(
  {},
  { Provider: CheckboxProvider, Control, Label, HiddenInput }
);
export {
  Checkbox,
  useCheckbox
};
